---
title: Handling content breaks in multicol
slug: Web/CSS/CSS_Columns/Handling_content_breaks_in_multicol
tags:
  - CSS
  - CSS Multi-column Layout
  - Guide
  - Layout
---
<div>{{CSSRef}}</div>

<p class="summary">Content is broken between column boxes in multiple-column layout in the same way that it is broken between pages in paged media. In both contexts we control where and how things break by using properties of the CSS Fragmentation specification. In this guide we see how Fragmentation works in multicol.</p>

<h2 id="Fragmentation_basics">Fragmentation basics</h2>

<p>The <a href="https://www.w3.org/TR/css-break-3/">CSS Fragmentation specification </a>details how content breaks between the fragmentation containers, or <em>fragmentainers</em>. In multicol, the fragmentainer is the column box.</p>

<p>A column box can contain other markup and there are many places where a break would not be ideal. For example, we would generally prefer that the figcaption of an image not be separated into a new column away from the image it refers to and ending a column with a heading looks strange. The fragmentation properties give us ways to exercise some control over this.</p>

<p>There are various places we might want to control our breaks:</p>

<ul>
 <li>Breaks inside boxes, for example inside a figure element.</li>
 <li>Breaks before and after boxes, which would include our heading example above.</li>
 <li>Breaks between lines.</li>
</ul>

<h2 id="Breaks_inside_boxes">Breaks inside boxes</h2>

<p>To control breaks inside boxes use the {{cssxref("break-inside")}} property. This property takes values of:</p>

<ul>
 <li><code>auto</code></li>
 <li><code>avoid</code></li>
 <li><code>avoid-page</code></li>
 <li><code>avoid-column</code></li>
 <li><code>avoid-region</code></li>
</ul>

<p>In the example below, we have applied break-inside to the figure element to prevent the caption from becoming separated from the image.</p>

<p>{{EmbedGHLiveSample("css-examples/multicol/fragmentation/break-inside.html", '100%', 800)}}</p>

<h2 id="Breaks_before_and_after_boxes">Breaks before and after boxes</h2>

<p>The {{cssxref("break-before")}} and {{cssxref("break-after")}} properties are used to control breaks before and after elements. They take the following values when in a multicol context:</p>

<ul>
 <li>auto</li>
 <li>avoid</li>
 <li>avoid-column</li>
 <li>column</li>
</ul>

<p>In this next example, we are forcing a column break before an <code>h2</code> element.</p>

<p>{{EmbedGHLiveSample("css-examples/multicol/fragmentation/break-before.html", '100%', 800)}}</p>

<h2 id="Breaks_between_lines">Breaks between lines</h2>

<p>The {{cssxref("orphans")}} and {{cssxref("widows")}} properties are also useful. The orphans property controls the number of lines left on their own at the end of a fragment. The widows property controls the number left on their own at the start of a fragment.</p>

<p>The <code>orphans</code> and <code>widows</code> properties take an integer as a value, which represents the number of lines to keep together at the end and start of a fragment, respectively. Note that these properties only work inside a block container, such as a paragraph. If the block has fewer lines in it than the number that you specify as a value, all lines will be kept together.</p>

<p>In the example below, we are using the <code>orphans</code> property to control the number of lines left at the bottom of a column. You can change that value to see the effect on the breaking of the content.</p>

<p>{{EmbedGHLiveSample("css-examples/multicol/fragmentation/orphans.html", '100%', 800)}}</p>

<h2 id="When_things_don’t_work_as_expected">When things don’t work as expected</h2>

<p>If you have small amounts of content and are trying to control breaks in a number of ways or on several elements, your content needs to break somewhere, so you may not always get the result you intended. To some extent your use of fragmentation is always a suggestion to the browser, to control breaks in this way if it is possible.</p>

<p>In addition to the above, browser support for these properties is a little patchy. The compatibility data charts on the individual property pages here on MDN can help you see which browsers support which features. In most cases, the fallback to breaks not being controlled is something you can live with, with suboptimal breaking being untidy rather than a disaster to your layout.</p>
